<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<title>OpenThread: src/core/thread/topology.hpp Source File</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="../../Open-Thread-Logo-200x42.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">
   &#160;<span id="projectnumber">gddd0704</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "../../search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="../../index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="../../modules.html"><span>Modules</span></a></li>
      <li><a href="../../namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="../../annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="../../files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="../../search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="../../search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="../../files.html"><span>File&#160;List</span></a></li>
      <li><a href="../../globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('df/d4b/topology_8hpp_source.html','../../');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">topology.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="../../df/d4b/topology_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> *  Copyright (c) 2016, The OpenThread Authors.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *  All rights reserved.</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *  Redistribution and use in source and binary forms, with or without</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> *  modification, are permitted provided that the following conditions are met:</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> *  1. Redistributions of source code must retain the above copyright</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer.</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> *  2. Redistributions in binary form must reproduce the above copyright</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> *     notice, this list of conditions and the following disclaimer in the</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> *     documentation and/or other materials provided with the distribution.</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *  3. Neither the name of the copyright holder nor the</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> *     names of its contributors may be used to endorse or promote products</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> *     derived from this software without specific prior written permission.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS &quot;AS IS&quot;</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> *  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> *  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> *  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> *  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> *  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> *  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> *  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment"> *  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="comment"> *  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"> *  POSSIBILITY OF SUCH DAMAGE.</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;<span class="preprocessor">#ifndef TOPOLOGY_HPP_</span></div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="preprocessor">#define TOPOLOGY_HPP_</span></div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../df/dcb/openthread-core-config_8h.html">openthread-core-config.h</a>&gt;</span></div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/d97/mac__frame_8hpp.html">mac/mac_frame.hpp</a>&gt;</span></div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/dd4/ip6_8hpp.html">net/ip6.hpp</a>&gt;</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d1/df7/mle__tlvs_8hpp.html">thread/mle_tlvs.hpp</a>&gt;</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="../../d2/d49/link__quality_8hpp.html">thread/link_quality.hpp</a>&gt;</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;<span class="keyword">namespace </span><a class="code" href="../../d9/d00/namespaceThread.html">Thread</a> {</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00049"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html">   49</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a></div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;{</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00052"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ae0cee06d43705fd3d4c8dfc4776c4f8c">   52</a></span>&#160;    <a class="code" href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Mac::ExtAddress</a> <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ae0cee06d43705fd3d4c8dfc4776c4f8c">mMacAddr</a>;            </div><div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a196092c07e8f54b8e92fbb70ef199203">   53</a></span>&#160;    uint32_t        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a196092c07e8f54b8e92fbb70ef199203">mLastHeard</a>;          </div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keyword">union</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    {</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;        <span class="keyword">struct</span></div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        {</div><div class="line"><a name="l00058"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a25e063d8cb2a052425f9a7c529de4b22">   58</a></span>&#160;            uint32_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a25e063d8cb2a052425f9a7c529de4b22">mLinkFrameCounter</a>;  </div><div class="line"><a name="l00059"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a85277f348f381529be7cc5702848a9b9">   59</a></span>&#160;            uint32_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a85277f348f381529be7cc5702848a9b9">mMleFrameCounter</a>;   </div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a92dd82c88583d2e0a8a17ed3751560dc">   60</a></span>&#160;            uint16_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a92dd82c88583d2e0a8a17ed3751560dc">mRloc16</a>;            </div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        } mValid;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">struct</span></div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;        {</div><div class="line"><a name="l00064"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab92902c95b78e4b742966cef84ab9350">   64</a></span>&#160;            uint8_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab92902c95b78e4b742966cef84ab9350">mChallenge</a>[<a class="code" href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html#adcab3a1fe8d6eb53f12ea5d767cb1628a8735abacfa1e0b26c8f5bc0bd1c4cbca">Mle::ChallengeTlv::kMaxSize</a>];  </div><div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a1582bd23b78f413a112c36ad82318810">   65</a></span>&#160;            uint8_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a1582bd23b78f413a112c36ad82318810">mChallengeLength</a>;    </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        } mPending;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    };</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;</div><div class="line"><a name="l00069"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a01a8a9f7b7838a01d54251e535a20553">   69</a></span>&#160;    uint32_t <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a01a8a9f7b7838a01d54251e535a20553">mKeySequence</a>;               </div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;</div><div class="line"><a name="l00075"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cd">   75</a></span>&#160;    <span class="keyword">enum</span> <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cd">State</a></div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="preprocessor">#if _WIN32</span></div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;        : <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span></div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    {</div><div class="line"><a name="l00080"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda5e2e9154102031460ff8957e065df50d">   80</a></span>&#160;        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda5e2e9154102031460ff8957e065df50d">kStateInvalid</a>,                   </div><div class="line"><a name="l00081"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda3fffdebd52c89750d1ba00314b80300b">   81</a></span>&#160;        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda3fffdebd52c89750d1ba00314b80300b">kStateParentRequest</a>,             </div><div class="line"><a name="l00082"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda2cc238ad542e86b38b78cac50727affd">   82</a></span>&#160;        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda2cc238ad542e86b38b78cac50727affd">kStateChildIdRequest</a>,            </div><div class="line"><a name="l00083"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda19ec926f21de995bb0890add37f746b8">   83</a></span>&#160;        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda19ec926f21de995bb0890add37f746b8">kStateLinkRequest</a>,               </div><div class="line"><a name="l00084"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cdaa9798a643241b4326beea7c0bab7d18c">   84</a></span>&#160;        <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cdaa9798a643241b4326beea7c0bab7d18c">kStateValid</a>,                     </div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    };</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;</div><div class="line"><a name="l00087"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ae38900ccf7c8ed271c2d1072add36660">   87</a></span>&#160;    <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cd">State</a>           <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ae38900ccf7c8ed271c2d1072add36660">mState</a> : 3;          </div><div class="line"><a name="l00088"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a15f05d7037f87472ad7201f9a6a8c2d0">   88</a></span>&#160;    uint8_t         <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a15f05d7037f87472ad7201f9a6a8c2d0">mMode</a> : 4;           </div><div class="line"><a name="l00089"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ae4073f674b4f04c21dbda33ff0906abb">   89</a></span>&#160;    <span class="keywordtype">bool</span>            <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ae4073f674b4f04c21dbda33ff0906abb">mDataRequest</a> : 1;    </div><div class="line"><a name="l00090"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#ae30650fda4acc6dafdc9b57992414884">   90</a></span>&#160;    uint8_t         <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#ae30650fda4acc6dafdc9b57992414884">mLinkFailures</a>;       </div><div class="line"><a name="l00091"></a><span class="lineno"><a class="line" href="../../da/dd9/classThread_1_1Neighbor.html#a59cd22765c14d446c332b284642ddfb7">   91</a></span>&#160;    <a class="code" href="../../dd/d38/classThread_1_1LinkQualityInfo.html">LinkQualityInfo</a> <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html#a59cd22765c14d446c332b284642ddfb7">mLinkInfo</a>;           </div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;};</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;</div><div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html">   98</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../d3/de7/classThread_1_1Child.html">Child</a> : <span class="keyword">public</span> <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a></div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;{</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <span class="keyword">enum</span></div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    {</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        kMaxIp6AddressPerChild = <a class="code" href="../../d7/d08/openthread-core-default-config_8h.html#ae0283754d081146cc5cb039e1be25063">OPENTHREAD_CONFIG_IP_ADDRS_PER_CHILD</a>,</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    };</div><div class="line"><a name="l00105"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#aea7d23d9f8e098b0743548f0f9607459">  105</a></span>&#160;    <a class="code" href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Ip6::Address</a> mIp6Address[kMaxIp6AddressPerChild];  </div><div class="line"><a name="l00106"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#a697629615b61d57c8df5959d99848125">  106</a></span>&#160;    uint32_t     <a class="code" href="../../d3/de7/classThread_1_1Child.html#a697629615b61d57c8df5959d99848125">mTimeout</a>;                             </div><div class="line"><a name="l00107"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#ae4e2105e933582a4882d85f60f75d652">  107</a></span>&#160;    uint16_t     <a class="code" href="../../d3/de7/classThread_1_1Child.html#ae4e2105e933582a4882d85f60f75d652">mFragmentOffset</a>;                      </div><div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#a9d4eca3c560d00d63ec4ef341de94a58">  108</a></span>&#160;    uint8_t      mRequestTlvs[7];                      </div><div class="line"><a name="l00109"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#a9fbb910c8dd6654d97bcc29193ad4af7">  109</a></span>&#160;    uint8_t      <a class="code" href="../../d3/de7/classThread_1_1Child.html#a9fbb910c8dd6654d97bcc29193ad4af7">mNetworkDataVersion</a>;                  </div><div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#ae990e98b6b222966465ac89266cb1146">  110</a></span>&#160;    uint16_t     <a class="code" href="../../d3/de7/classThread_1_1Child.html#ae990e98b6b222966465ac89266cb1146">mQueuedIndirectMessageCnt</a>;            </div><div class="line"><a name="l00111"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#a969e6c8148a6c76e30e1f33a7c79ab38">  111</a></span>&#160;    <span class="keywordtype">bool</span>         <a class="code" href="../../d3/de7/classThread_1_1Child.html#a969e6c8148a6c76e30e1f33a7c79ab38">mAddSrcMatchEntryShort</a>;               </div><div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="../../d3/de7/classThread_1_1Child.html#a037eb024c680f287cfd77b28f2473cf9">  112</a></span>&#160;    <span class="keywordtype">bool</span>         <a class="code" href="../../d3/de7/classThread_1_1Child.html#a037eb024c680f287cfd77b28f2473cf9">mAddSrcMatchEntryPending</a>;             </div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;};</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;</div><div class="line"><a name="l00119"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html">  119</a></span>&#160;<span class="keyword">class </span><a class="code" href="../../db/d81/classThread_1_1Router.html">Router</a> : <span class="keyword">public</span> <a class="code" href="../../da/dd9/classThread_1_1Neighbor.html">Neighbor</a></div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;{</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00122"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html#a12d0a442a0454213c3830d8a5ec8fd2d">  122</a></span>&#160;    uint8_t <a class="code" href="../../db/d81/classThread_1_1Router.html#a12d0a442a0454213c3830d8a5ec8fd2d">mNextHop</a>;             </div><div class="line"><a name="l00123"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html#a685707e1e0f1724421dd81bd34ac9b61">  123</a></span>&#160;    uint8_t mLinkQualityOut : 2;  </div><div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html#ad1d838013251a1749007fae151094090">  124</a></span>&#160;    uint8_t mCost : 4;            </div><div class="line"><a name="l00125"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html#a43c6dcb843c3f8e7fe09136f91f1b59f">  125</a></span>&#160;    <span class="keywordtype">bool</span>    mAllocated : 1;       </div><div class="line"><a name="l00126"></a><span class="lineno"><a class="line" href="../../db/d81/classThread_1_1Router.html#af67a88b4e30a464ea235307fbb134b84">  126</a></span>&#160;    <span class="keywordtype">bool</span>    mReclaimDelay : 1;    </div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;};</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;}  <span class="comment">// namespace Thread</span></div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;<span class="preprocessor">#endif  // TOPOLOGY_HPP_</span></div><div class="ttc" id="classThread_1_1Neighbor_html"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html">Thread::Neighbor</a></div><div class="ttdoc">This class represents a Thread neighbor. </div><div class="ttdef"><b>Definition:</b> topology.hpp:49</div></div>
<div class="ttc" id="classThread_1_1Router_html_a12d0a442a0454213c3830d8a5ec8fd2d"><div class="ttname"><a href="../../db/d81/classThread_1_1Router.html#a12d0a442a0454213c3830d8a5ec8fd2d">Thread::Router::mNextHop</a></div><div class="ttdeci">uint8_t mNextHop</div><div class="ttdoc">The next hop towards this router. </div><div class="ttdef"><b>Definition:</b> topology.hpp:122</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cda5e2e9154102031460ff8957e065df50d"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda5e2e9154102031460ff8957e065df50d">Thread::Neighbor::kStateInvalid</a></div><div class="ttdoc">Neighbor link is invalid. </div><div class="ttdef"><b>Definition:</b> topology.hpp:80</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a1582bd23b78f413a112c36ad82318810"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a1582bd23b78f413a112c36ad82318810">Thread::Neighbor::mChallengeLength</a></div><div class="ttdeci">uint8_t mChallengeLength</div><div class="ttdoc">The challenge length. </div><div class="ttdef"><b>Definition:</b> topology.hpp:65</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cda2cc238ad542e86b38b78cac50727affd"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda2cc238ad542e86b38b78cac50727affd">Thread::Neighbor::kStateChildIdRequest</a></div><div class="ttdoc">Received an MLE Child ID Request message. </div><div class="ttdef"><b>Definition:</b> topology.hpp:82</div></div>
<div class="ttc" id="classThread_1_1Child_html_a9fbb910c8dd6654d97bcc29193ad4af7"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#a9fbb910c8dd6654d97bcc29193ad4af7">Thread::Child::mNetworkDataVersion</a></div><div class="ttdeci">uint8_t mNetworkDataVersion</div><div class="ttdoc">Current Network Data version. </div><div class="ttdef"><b>Definition:</b> topology.hpp:109</div></div>
<div class="ttc" id="classThread_1_1Child_html"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html">Thread::Child</a></div><div class="ttdoc">This class represents a Thread Child. </div><div class="ttdef"><b>Definition:</b> topology.hpp:98</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a196092c07e8f54b8e92fbb70ef199203"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a196092c07e8f54b8e92fbb70ef199203">Thread::Neighbor::mLastHeard</a></div><div class="ttdeci">uint32_t mLastHeard</div><div class="ttdoc">Time when last heard. </div><div class="ttdef"><b>Definition:</b> topology.hpp:53</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a92dd82c88583d2e0a8a17ed3751560dc"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a92dd82c88583d2e0a8a17ed3751560dc">Thread::Neighbor::mRloc16</a></div><div class="ttdeci">uint16_t mRloc16</div><div class="ttdoc">The RLOC16. </div><div class="ttdef"><b>Definition:</b> topology.hpp:60</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ae30650fda4acc6dafdc9b57992414884"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ae30650fda4acc6dafdc9b57992414884">Thread::Neighbor::mLinkFailures</a></div><div class="ttdeci">uint8_t mLinkFailures</div><div class="ttdoc">Consecutive link failure count. </div><div class="ttdef"><b>Definition:</b> topology.hpp:90</div></div>
<div class="ttc" id="classThread_1_1LinkQualityInfo_html"><div class="ttname"><a href="../../dd/d38/classThread_1_1LinkQualityInfo.html">Thread::LinkQualityInfo</a></div><div class="ttdoc">This class encapsulates/stores all relevant information about quality of a link, including average re...</div><div class="ttdef"><b>Definition:</b> link_quality.hpp:56</div></div>
<div class="ttc" id="classThread_1_1Child_html_a037eb024c680f287cfd77b28f2473cf9"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#a037eb024c680f287cfd77b28f2473cf9">Thread::Child::mAddSrcMatchEntryPending</a></div><div class="ttdeci">bool mAddSrcMatchEntryPending</div><div class="ttdoc">Indicates whether or not pending to add. </div><div class="ttdef"><b>Definition:</b> topology.hpp:112</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cd"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cd">Thread::Neighbor::State</a></div><div class="ttdeci">State</div><div class="ttdoc">Neighbor link states. </div><div class="ttdef"><b>Definition:</b> topology.hpp:75</div></div>
<div class="ttc" id="classThread_1_1Child_html_a697629615b61d57c8df5959d99848125"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#a697629615b61d57c8df5959d99848125">Thread::Child::mTimeout</a></div><div class="ttdeci">uint32_t mTimeout</div><div class="ttdoc">Child timeout. </div><div class="ttdef"><b>Definition:</b> topology.hpp:106</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ae38900ccf7c8ed271c2d1072add36660"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ae38900ccf7c8ed271c2d1072add36660">Thread::Neighbor::mState</a></div><div class="ttdeci">State mState</div><div class="ttdoc">The link state. </div><div class="ttdef"><b>Definition:</b> topology.hpp:87</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a15f05d7037f87472ad7201f9a6a8c2d0"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a15f05d7037f87472ad7201f9a6a8c2d0">Thread::Neighbor::mMode</a></div><div class="ttdeci">uint8_t mMode</div><div class="ttdoc">The MLE device mode. </div><div class="ttdef"><b>Definition:</b> topology.hpp:88</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a85277f348f381529be7cc5702848a9b9"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a85277f348f381529be7cc5702848a9b9">Thread::Neighbor::mMleFrameCounter</a></div><div class="ttdeci">uint32_t mMleFrameCounter</div><div class="ttdoc">The MLE Frame Counter. </div><div class="ttdef"><b>Definition:</b> topology.hpp:59</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ae0cee06d43705fd3d4c8dfc4776c4f8c"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ae0cee06d43705fd3d4c8dfc4776c4f8c">Thread::Neighbor::mMacAddr</a></div><div class="ttdeci">Mac::ExtAddress mMacAddr</div><div class="ttdoc">The IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> topology.hpp:52</div></div>
<div class="ttc" id="mac__frame_8hpp_html"><div class="ttname"><a href="../../d1/d97/mac__frame_8hpp.html">mac_frame.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing IEEE 802.15.4 MAC frames. </div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a59cd22765c14d446c332b284642ddfb7"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a59cd22765c14d446c332b284642ddfb7">Thread::Neighbor::mLinkInfo</a></div><div class="ttdeci">LinkQualityInfo mLinkInfo</div><div class="ttdoc">Link quality info (contains average RSS, link margin and link quality) </div><div class="ttdef"><b>Definition:</b> topology.hpp:91</div></div>
<div class="ttc" id="mle__tlvs_8hpp_html"><div class="ttname"><a href="../../d1/df7/mle__tlvs_8hpp.html">mle_tlvs.hpp</a></div><div class="ttdoc">This file includes definitions for generating and processing MLE TLVs. </div></div>
<div class="ttc" id="classThread_1_1Mle_1_1ChallengeTlv_html_adcab3a1fe8d6eb53f12ea5d767cb1628a8735abacfa1e0b26c8f5bc0bd1c4cbca"><div class="ttname"><a href="../../da/d3f/classThread_1_1Mle_1_1ChallengeTlv.html#adcab3a1fe8d6eb53f12ea5d767cb1628a8735abacfa1e0b26c8f5bc0bd1c4cbca">Thread::Mle::ChallengeTlv::kMaxSize</a></div><div class="ttdoc">Maximum size in bytes (Thread Specification). </div><div class="ttdef"><b>Definition:</b> mle_tlvs.hpp:316</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cda19ec926f21de995bb0890add37f746b8"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda19ec926f21de995bb0890add37f746b8">Thread::Neighbor::kStateLinkRequest</a></div><div class="ttdoc">Sent a MLE Link Request message. </div><div class="ttdef"><b>Definition:</b> topology.hpp:83</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab92902c95b78e4b742966cef84ab9350"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab92902c95b78e4b742966cef84ab9350">Thread::Neighbor::mChallenge</a></div><div class="ttdeci">uint8_t mChallenge[Mle::ChallengeTlv::kMaxSize]</div><div class="ttdoc">The challenge value. </div><div class="ttdef"><b>Definition:</b> topology.hpp:64</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cda3fffdebd52c89750d1ba00314b80300b"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cda3fffdebd52c89750d1ba00314b80300b">Thread::Neighbor::kStateParentRequest</a></div><div class="ttdoc">Received an MLE Parent Request message. </div><div class="ttdef"><b>Definition:</b> topology.hpp:81</div></div>
<div class="ttc" id="classThread_1_1Child_html_ae4e2105e933582a4882d85f60f75d652"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#ae4e2105e933582a4882d85f60f75d652">Thread::Child::mFragmentOffset</a></div><div class="ttdeci">uint16_t mFragmentOffset</div><div class="ttdoc">6LoWPAN fragment offset </div><div class="ttdef"><b>Definition:</b> topology.hpp:107</div></div>
<div class="ttc" id="ip6_8hpp_html"><div class="ttname"><a href="../../d1/dd4/ip6_8hpp.html">ip6.hpp</a></div><div class="ttdoc">This file includes definitions for IPv6 packet processing. </div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ab01d7958f449ab7d7f163f00110e80cdaa9798a643241b4326beea7c0bab7d18c"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ab01d7958f449ab7d7f163f00110e80cdaa9798a643241b4326beea7c0bab7d18c">Thread::Neighbor::kStateValid</a></div><div class="ttdoc">Link is valid. </div><div class="ttdef"><b>Definition:</b> topology.hpp:84</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a25e063d8cb2a052425f9a7c529de4b22"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a25e063d8cb2a052425f9a7c529de4b22">Thread::Neighbor::mLinkFrameCounter</a></div><div class="ttdeci">uint32_t mLinkFrameCounter</div><div class="ttdoc">The Link Frame Counter. </div><div class="ttdef"><b>Definition:</b> topology.hpp:58</div></div>
<div class="ttc" id="openthread-core-default-config_8h_html_ae0283754d081146cc5cb039e1be25063"><div class="ttname"><a href="../../d7/d08/openthread-core-default-config_8h.html#ae0283754d081146cc5cb039e1be25063">OPENTHREAD_CONFIG_IP_ADDRS_PER_CHILD</a></div><div class="ttdeci">#define OPENTHREAD_CONFIG_IP_ADDRS_PER_CHILD</div><div class="ttdoc">The minimum number of supported IPv6 address registrations per child. </div><div class="ttdef"><b>Definition:</b> openthread-core-default-config.h:115</div></div>
<div class="ttc" id="classThread_1_1Child_html_a969e6c8148a6c76e30e1f33a7c79ab38"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#a969e6c8148a6c76e30e1f33a7c79ab38">Thread::Child::mAddSrcMatchEntryShort</a></div><div class="ttdeci">bool mAddSrcMatchEntryShort</div><div class="ttdoc">Indicates whether or not to force add short address. </div><div class="ttdef"><b>Definition:</b> topology.hpp:111</div></div>
<div class="ttc" id="classThread_1_1Child_html_ae990e98b6b222966465ac89266cb1146"><div class="ttname"><a href="../../d3/de7/classThread_1_1Child.html#ae990e98b6b222966465ac89266cb1146">Thread::Child::mQueuedIndirectMessageCnt</a></div><div class="ttdeci">uint16_t mQueuedIndirectMessageCnt</div><div class="ttdoc">Count of queued messages. </div><div class="ttdef"><b>Definition:</b> topology.hpp:110</div></div>
<div class="ttc" id="classThread_1_1Mac_1_1ExtAddress_html"><div class="ttname"><a href="../../d9/d3c/classThread_1_1Mac_1_1ExtAddress.html">Thread::Mac::ExtAddress</a></div><div class="ttdoc">This structure represents an IEEE 802.15.4 Extended Address. </div><div class="ttdef"><b>Definition:</b> mac_frame.hpp:81</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_ae4073f674b4f04c21dbda33ff0906abb"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#ae4073f674b4f04c21dbda33ff0906abb">Thread::Neighbor::mDataRequest</a></div><div class="ttdeci">bool mDataRequest</div><div class="ttdoc">Indicates whether or not a Data Poll was received. </div><div class="ttdef"><b>Definition:</b> topology.hpp:89</div></div>
<div class="ttc" id="classThread_1_1Neighbor_html_a01a8a9f7b7838a01d54251e535a20553"><div class="ttname"><a href="../../da/dd9/classThread_1_1Neighbor.html#a01a8a9f7b7838a01d54251e535a20553">Thread::Neighbor::mKeySequence</a></div><div class="ttdeci">uint32_t mKeySequence</div><div class="ttdoc">Current key sequence. </div><div class="ttdef"><b>Definition:</b> topology.hpp:69</div></div>
<div class="ttc" id="namespaceThread_html"><div class="ttname"><a href="../../d9/d00/namespaceThread.html">Thread</a></div><div class="ttdef"><b>Definition:</b> cli.cpp:61</div></div>
<div class="ttc" id="openthread-core-config_8h_html"><div class="ttname"><a href="../../df/dcb/openthread-core-config_8h.html">openthread-core-config.h</a></div><div class="ttdoc">This file includes compile-time configuration constants for OpenThread. </div></div>
<div class="ttc" id="classThread_1_1Router_html"><div class="ttname"><a href="../../db/d81/classThread_1_1Router.html">Thread::Router</a></div><div class="ttdoc">This class represents a Thread Router. </div><div class="ttdef"><b>Definition:</b> topology.hpp:119</div></div>
<div class="ttc" id="link__quality_8hpp_html"><div class="ttname"><a href="../../d2/d49/link__quality_8hpp.html">link_quality.hpp</a></div><div class="ttdoc">This file includes definitions for storing and processing link quality information. </div></div>
<div class="ttc" id="classThread_1_1Ip6_1_1Address_html"><div class="ttname"><a href="../../d9/db1/classThread_1_1Ip6_1_1Address.html">Thread::Ip6::Address</a></div><div class="ttdoc">This class implements an IPv6 address object. </div><div class="ttdef"><b>Definition:</b> ip6_address.hpp:56</div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="../../dir_aebb8dcc11953d78e620bbef0b9e2183.html">core</a></li><li class="navelem"><a class="el" href="../../dir_fd71accbf528c1576ca21e7ec5716833.html">thread</a></li><li class="navelem"><a class="el" href="../../df/d4b/topology_8hpp.html">topology.hpp</a></li>
    <li class="footer">Generated on Fri Oct 14 2016 08:44:34 for OpenThread by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="../../doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
